/*
   DrawLine program for drawing the truss member:
  -Lines can be drawn by LeftClick-dragging the mouse. 
  -RighClick : Undo
  -MiddleClick : Clear
   Neda M
 
*/


#include <iostream>
#include <GL/glut.h>

using namespace std;

const int MAX_LINES = 1000000; 
float r = 10; //halo radius.
float xt=0; // truss node coordinates
float yt=0;

struct LinePos {
   float x1, y1;  // StartPoint
   float x2, y2;  // EndPoint
};

LinePos lines[MAX_LINES]; 
int Numlines = 0;  

int width;   
int height;  

bool mouseMove = false;  
//int mouseMoveHold;    
                    

//Mouse Pressed
void StartDrawLine(float x, float y) {
   if (Numlines == MAX_LINES) {
      cout << "Maximum Lines Achieved.\n";
      return;
   }
   mouseMove = true;   // Drawing in progress.
   //mouseMoveHold = Hold;

   lines[Numlines].x1 = x;   
   lines[Numlines].y1 = y;   
   lines[Numlines].x2 = x;   
   lines[Numlines].y2 = y;  
   Numlines++;
}

//Mouse Moving
void DrawLine(float x, float y) {
   if (!mouseMove)
      return;
   int crtLine = Numlines - 1;  // Current position of drawing.
                              
   lines[crtLine].x2 = x;  // New End Point
   lines[crtLine].y2 = y;
   glutPostRedisplay(); 
}

//Mouse Released
void FinishDrawLine(float x, float y) {
   if (!mouseMove)
      return;
   mouseMove = false;   
   int crtLine = Numlines - 1;  
   if (lines[crtLine].x1 == lines[crtLine].x2 &&
      lines[crtLine].y1 == lines[crtLine].y2) {
      Numlines--;  
   }
   /*else
   xt = lines[crtLine].x2;
   yt = lines[crtLine].y2;*/

   glutPostRedisplay(); 
   
}



void drawLines() {
     //(0,0) = bottom left.
	 //(1,1) = top right.
     // glLineWidth(10.0);
	glColor3f(0,0,0);  
   for (int i = 0; i < Numlines; i++) {
      glBegin(GL_LINES);
	     glVertex2f(lines[i].x1, lines[i].y1);
         glVertex2f(lines[i].x2, lines[i].y2);
      glEnd();
	  //glEnable(GL_LINE_SMOOTH);
   }
}

void init(float x1, float x2, float y1, float y2) {
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(x1,x2,y1,y2);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
}


void display() {
   glClearColor(1.0,1.0,1.0,1.0);  
   glClear(GL_COLOR_BUFFER_BIT);   

   glViewport(0,0,width,height); 
   init(0,1,0,1);
   drawLines();  
   glutSwapBuffers(); 
}


void reshape(int new_width, int new_height) {
   height = new_height;
   width = new_width;
   glViewport(0,0,width,height);
}


//  (x,y)= Mouse Position.
//  (0,0)= top left 
//  (width,height)= bottom right.

void mouse(int button, int state, int x, int y) {

		  float wx, wy; 
	//Undo
	if (button == GLUT_RIGHT_BUTTON) {
      if (Numlines > 0) {
		 Numlines = Numlines + 1;
         Numlines--;
         glutPostRedisplay();
		}	
      }
	//Clear
	if (button == GLUT_MIDDLE_BUTTON) {
      Numlines = 0;
      glutPostRedisplay();
	}
	//Draw
      else if (button == GLUT_LEFT_BUTTON) {
		  printf("x = %f\n, y=%f\n", x, y);
			  xt = x; //stores the x-position of end points
			  yt = y; //stores the y-position of the end points
			  FinishDrawLine(wx,wy);
		  wx = (float)(x)/(width);
		  wy = (float)(height-y)/height;

		  printf("wx = %f\n, wy=%f\n", wx, wy);
		  
		  /*if ((x < (xt + r)) && (y < (yt + r)) && (state == GLUT_DOWN)) {  // Mouse cursor is a halo/square of a possible node
			  int crtLine = Numlines - 1; 
			  lines[crtLine].x2 = xt;
			  lines[crtLine].y2 = yt;
			  */
			  StartDrawLine(xt,yt);
		  printf("xt = %f\n, yt=%f\n", xt, yt);
		  }
		  /*else if ((state == GLUT_DOWN))
		  {
					wx=wx+1;
				  StartDrawLine(wx,wy);
		  }
		  */
		  else
		  {
		  }
   //}
}


void motion(int x, int y) {
   if (mouseMove) {
      float wx, wy; 
      wx = (float)(x)/width;
      wy = (float)(height-y)/height;
      DrawLine(wx,wy); 
	  StartDrawLine(wx,wy);
   }
   
}


int main(int argc, char **argv) {

   glutInit(&argc,argv);
   glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
   glutInitWindowSize(800,500);      
   glutInitWindowPosition(200,200);    
   glutCreateWindow("Draw Truss"); 
   
   glutDisplayFunc(display);
   glutReshapeFunc(reshape);

   glutMouseFunc(mouse);       
   glutMotionFunc(motion);        
   glutMainLoop();
}   
