#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>
#include <math.h>
#include <string.h>
#include "trackball.h"

struct POINT {
    GLfloat x;
    GLfloat y;
    GLfloat z;
};

int xdim=0,  zdim=0, xdim2=0, zdim2=0;

struct POINT **CtrlPoints, **CtrlPoints2;

int in_box = -1;
int off_x, off_y;

extern GLfloat zoom;
extern GLfloat tbx;
extern GLfloat tby;

char *filename ;


GLint mouse_state = -1;
GLint mouse_button = -1;
int ni=0, nj=0;
int check=0;

int target_point=0;

float max_x, max_y, max_z, min_x, min_y, min_z;
int width;
int SELECTED = GL_FALSE;
GLdouble wx[4][4], wy[4][4], wz[4][4];

void move_ctrlpoint(int x, int y);


void init()
{
    float tmp;
    int i, j, k;
    FILE *inf;
#define LINE_SIZE 1024
    char buffer[LINE_SIZE];

    tbInit(GLUT_MIDDLE_BUTTON);

    inf = fopen(filename, "r");
    if(inf==NULL) {
	printf("Error in open file!\n");
	exit(0);
    }
    
    // read the first layer
    fgets(buffer, LINE_SIZE, inf);
    sscanf(buffer, "%d %d", &xdim, &zdim);
    printf("buffer = %s, xdim = %d, zdim=%d\n", buffer, xdim, zdim);

    CtrlPoints = (POINT **)malloc(xdim*sizeof(POINT *));
    for(int i=0; i<xdim; i++) {
      CtrlPoints[i]= (POINT *)malloc(zdim*sizeof(POINT));
    }

    for(i=0; i<xdim; i++) {
      for(j=0; j<zdim; j++) {
        int index = i*xdim+j;
        fgets(buffer, LINE_SIZE, inf);
        
        sscanf(buffer, "%f %f %f %f", &tmp,
        &(CtrlPoints[i][j].x), &(CtrlPoints[i][j].y), &(CtrlPoints[i][j].z));
        CtrlPoints[i][j].x *=0.1;
        CtrlPoints[i][j].y *=0.1;
        CtrlPoints[i][j].z *=0.1;
      }
    }

    // read the second layer
    fgets(buffer, LINE_SIZE, inf);
    sscanf(buffer, "%d %d", &xdim2, &zdim2);
    printf("buffer2 = %s, xdim2 = %d, zdim2=%d\n", buffer, xdim2, zdim2);

    CtrlPoints2 = (POINT **)malloc(xdim*sizeof(POINT *));
    for(int i=0; i<xdim2; i++) {
      CtrlPoints2[i]= (POINT *)malloc(zdim2*sizeof(POINT));
    }

    for(i=0; i<xdim2; i++) {
      for(j=0; j<zdim2; j++) {
        int index = i*xdim2+j;
        fgets(buffer, LINE_SIZE, inf);
        
        sscanf(buffer, "%f %f %f", 
        &(CtrlPoints2[i][j].x), &(CtrlPoints2[i][j].y), &(CtrlPoints2[i][j].z));
        CtrlPoints2[i][j].x *=0.1;
        CtrlPoints2[i][j].y *=0.1;
        CtrlPoints2[i][j].z *=0.1;
      }
    }

    fclose(inf);
}

void draw_Ctrl_Points()
{
    int i,j;
   
    // draw the first layer
    glColor3f(1.0, 1.0, 1.0);
    glPointSize(3.0);
    glBegin(GL_POINTS);
    for(i=0; i<xdim; i++) {
	for(j=0; j<zdim; j++)
            glVertex3f(CtrlPoints[i][j].x, CtrlPoints[i][j].y,
			CtrlPoints[i][j].z);
    }
    glEnd();


    glPointSize(2.0);
    glColor3f(1.0, 1.0, 0.0);
    for(i=0; i<xdim; i++) {
	glBegin(GL_LINE_STRIP);
	for(j=0; j<zdim; j++)
            glVertex3f(CtrlPoints[i][j].x, CtrlPoints[i][j].y,
			CtrlPoints[i][j].z);
        glEnd();
    }

    for(j=0; j<zdim; j++) {
	glBegin(GL_LINE_STRIP);
        for(i=0; i<xdim; i++) 
            glVertex3f(CtrlPoints[i][j].x, CtrlPoints[i][j].y,
			CtrlPoints[i][j].z);
        glEnd();
    }

    // draw the second layer
    glColor3f(1.0, 0.0, 0.0);
    glPointSize(3.0);
    glBegin(GL_POINTS);
    for(i=0; i<xdim2; i++) {
	for(j=0; j<zdim2; j++)
            glVertex3f(CtrlPoints2[i][j].x, CtrlPoints2[i][j].y,
			CtrlPoints2[i][j].z);
    }
    glEnd();


    glPointSize(2.0);
    glColor3f(0.0, 0.0, 1.0);
    //glColor3f(1.0, 1.0, 0.0);
    for(i=0; i<xdim2; i++) {
	glBegin(GL_LINE_STRIP);
	for(j=0; j<zdim2; j++)
            glVertex3f(CtrlPoints2[i][j].x, CtrlPoints2[i][j].y,
			CtrlPoints2[i][j].z);
        glEnd();
    }

    for(j=0; j<zdim2; j++) {
	glBegin(GL_LINE_STRIP);
        for(i=0; i<xdim2; i++) 
            glVertex3f(CtrlPoints2[i][j].x, CtrlPoints2[i][j].y,
			CtrlPoints2[i][j].z);
        glEnd();
    }

    // connect the two layers
    glColor3f(0,1,0);
    //glColor3f(1.0, 1.0, 0.0);
    for(i=0; i<xdim2; i++) {
      for(j=0; j<zdim2; j++) {
        glBegin(GL_LINE_STRIP);
            glVertex3f(CtrlPoints2[i][j].x, CtrlPoints2[i][j].y,
			CtrlPoints2[i][j].z);
            glVertex3f(CtrlPoints[i][j].x, CtrlPoints[i][j].y,
			CtrlPoints[i][j].z);
            glVertex3f(CtrlPoints2[i][j].x, CtrlPoints2[i][j].y,
			CtrlPoints2[i][j].z);
            glVertex3f(CtrlPoints[i][j+1].x, CtrlPoints[i][j+1].y,
			CtrlPoints[i][j+1].z);
            glVertex3f(CtrlPoints2[i][j].x, CtrlPoints2[i][j].y,
			CtrlPoints2[i][j].z);
            glVertex3f(CtrlPoints[i+1][j+1].x, CtrlPoints[i+1][j+1].y,
			CtrlPoints[i+1][j+1].z);
            glVertex3f(CtrlPoints2[i][j].x, CtrlPoints2[i][j].y,
			CtrlPoints2[i][j].z);
            glVertex3f(CtrlPoints[i+1][j].x, CtrlPoints[i+1][j].y,
			CtrlPoints[i+1][j].z);
        glEnd();
      };
    };

}

void print_grid()
{
    int i, j;
    for(i=0; i<xdim; i++) {
	for(j=0; j<zdim; j++) 
	    printf("(%4.2f, %4.2f, %4.2f) ", CtrlPoints[i][j].x, CtrlPoints[i][j].y,
		CtrlPoints[i][j].z );
	printf("\n");
    }
}

void display(void)
{
    glClear (GL_COLOR_BUFFER_BIT);
    glPushMatrix();
    tbMatrix();

    draw_Ctrl_Points();

    glPopMatrix();
    glFlush();
}

void reshape(int w, int h)
{

    width = w;
    tbReshape(w, h);

    glViewport(0, 0, (GLsizei) w, (GLsizei) h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    gluPerspective(60.0, (GLfloat)w/(GLfloat)h, 0., 60.0);
    //glFrustum(-4., 4., -4., 4., 10, 30.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glTranslatef(-1.3, 0.0, -10.0+zoom);

}


void mouse(int button, int state, int x, int y)
{

    mouse_state = state;
    mouse_button = button;

    if(button == GLUT_LEFT_BUTTON && state == GLUT_UP) { 
	SELECTED = GL_FALSE;
    }
    else 
	tbMouse(button, state, x, y);
    glutPostRedisplay();


}

void keyboard(unsigned char key, int x, int y)
{
    int i, j;
    switch (key) {
      	case 27:
            exit(0);
            break;
	case 'n':
	    target_point = (target_point + 1)%16;
	    break;
	case 'x':
	    if(SELECTED)
	        CtrlPoints[ni][nj].x+=.1;
	    break;
	case 'X':
	    if(SELECTED)
	        CtrlPoints[ni][nj].x-=.1;
	    break;
	case 'y':
	    if(SELECTED)
	        CtrlPoints[ni][nj].y+=.1;
	    break;
	case 'Y':
	    if(SELECTED)
	        CtrlPoints[ni][nj].y-=.1;
	    break;
	case 'z':
	    if(SELECTED)
	        CtrlPoints[ni][nj].z+=.1;
	    break;
	case 'Z':
	    if(SELECTED)
	        CtrlPoints[ni][nj].z-=.1;
	    break;
    }
    glutPostRedisplay();
}

void
special(int key, int x, int y)
{
    switch (key) {
	case GLUT_KEY_RIGHT:
	    translate(0.5, 0);
	    break;	
	case GLUT_KEY_LEFT:
	    translate(-0.5, 0);
	    break;	
	case GLUT_KEY_UP:
	    translate(.0, 0.5);
	    break;	
	case GLUT_KEY_DOWN:
	    translate(.0, -0.5);
	    break;	
   }
   glutPostRedisplay();
}

void
motion(int x, int y)
{
    if((mouse_button == GLUT_LEFT_BUTTON) && (mouse_state==GLUT_DOWN)) {
    }
    else
       tbMotion(x, y, mouse_button);
    glutPostRedisplay();
}

int main(int argc, char **argv)
{
   if(argc!=2) {
     printf("Usage: ./obj/RenderMatlabPatch infilename\n");
     exit(-1);
   };
   
   filename = strdup(argv[1]);

   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
   glutInitWindowSize (500, 500);
   glutInitWindowPosition (100, 100);
   glutCreateWindow ("Render frame structure");
   init();
   glutDisplayFunc(display);
   glutReshapeFunc(reshape);
   glutMouseFunc(mouse);
   glutMotionFunc(motion);

   glutKeyboardFunc (keyboard);
   glutSpecialFunc(special);

   glutMainLoop();
   return 0;
}


