
// Jian Chen
// simple line drawing / editing code
// Apr 1 2012


#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>

#define NUM_POINTS 9

// 
// nodes coordinates
// * if you like to add the number of nodes
// * update the NUM_POINTS;
GLfloat CtrlPoints[NUM_POINTS][2] = { {50, 150}, {100., 100.}, {150., 150.},
                        {200., 100.}, {250., 150.}, {300., 100.}, {350., 150.}, {400, 100},
						{450, 150}};

// flag: mouse cursor in box or not. if yes, in_box=1; otherwise, in_box=-1;
int in_box = -1;

// the halo around your cursor (the red box in the picture; 
int off_x, off_y;

// init function - 
void init()
{
}

// draw those red boxes 
void draw_Ctrl_Points()
{
    int i;
    glColor3f(1.0, 1.0, 1.0);
    glBegin(GL_POINTS);
    glPointSize(4.0);
    for(i=0; i<NUM_POINTS; i++)
        glVertex2f(CtrlPoints[i][0], CtrlPoints[i][1]);
    glEnd();

    glBegin(GL_LINE_STRIP);
    for(i=0; i<NUM_POINTS; i++)
        glVertex2f(CtrlPoints[i][0], CtrlPoints[i][1]);
    glEnd();

    for(i=0; i<NUM_POINTS; i++) {
        glBegin(GL_LINE_LOOP);
        
        if(i== in_box) 
          glColor3f(0.0,  1.0, 1.0);
        else
          glColor3f(1.0, 0.0, 0.0);
        glVertex2f(CtrlPoints[i][0] -5., CtrlPoints[i][1] - 5.);
        glVertex2f(CtrlPoints[i][0] -5., CtrlPoints[i][1] + 5);
        glVertex2f(CtrlPoints[i][0] + 5.,  CtrlPoints[i][1] + 5.);
        glVertex2f(CtrlPoints[i][0] +5. ,  CtrlPoints[i][1] -5.);
        
        glEnd();
    }
}

// display playback routine
// this will be called in every loop
void display(void)
{
    glClear (GL_COLOR_BUFFER_BIT);
    draw_Ctrl_Points();

    glFlush();
}

// called when the window is resized; 
// graphics will be adjusted accordingly
void reshape(int w, int h)
{
   glViewport(0, 0, (GLsizei) w, (GLsizei) h);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glOrtho(0.0, 500.0, 500.0, 0.0, -10.0, 10.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
}

// mouse callback
// detect if the mouse cursor is inside the box or not.
// if inside, in_box will be equal to the node index
void mouse(int button, int state, int x, int y)
{
    int i;


    switch (button) {
      case GLUT_LEFT_BUTTON:
                
        if (state == GLUT_UP) {

            if(in_box != -1) {
                CtrlPoints[in_box][0] = (float)(x-off_x);
                CtrlPoints[in_box][1] = (float)(y-off_y);
                init();
            }
            in_box = -1;
        
        }
        if (state == GLUT_DOWN) {
            in_box = -1;
            for(i=0; i<NUM_POINTS; i++) {
                if( (x > (int)(CtrlPoints[i][0] - 15.)) 
                 && (y > (int)(CtrlPoints[i][1] -  15.))
                 && (x < (int)(CtrlPoints[i][0] +  15.))
                 && (y < (int)(CtrlPoints[i][1] +  15.)))
            {
                in_box = i;

                off_x = x - (int)(CtrlPoints[i][0]);
                off_y = y - (int)(CtrlPoints[i][1]);
                break;
             }
            } 
         }
         break;
      default:
         break;
   }

   glFlush();
   display();

}

void keyboard(unsigned char key, int x, int y)
{
   switch (key) {
      case 27:
         exit(0);
         break;
   }
}

// main function
/// 
int main(int argc, char **argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
   glutInitWindowSize (500, 500);
   glutInitWindowPosition (100, 100);
   glutCreateWindow (argv[0]);
   init();
   glutDisplayFunc(display);
   glutReshapeFunc(reshape);
   glutMouseFunc(mouse);
   glutKeyboardFunc (keyboard);
   glutMainLoop();
   return 0;
}
